package io.xjar.filter;

import java.util.LinkedHashSet;
import java.util.Collection;
import java.util.Set;
import io.xjar.XEntryFilter;

public abstract class XMixEntryFilter<E> implements XEntryFilter<E>
{
    protected final Set<XEntryFilter<? extends E>> filters;
    
    protected XMixEntryFilter() {
        this(null);
    }
    
    protected XMixEntryFilter(final Collection<? extends XEntryFilter<? extends E>> filters) {
        this.filters = ((filters != null) ? new LinkedHashSet<XEntryFilter<? extends E>>(filters) : new LinkedHashSet<XEntryFilter<? extends E>>());
    }
    
    public boolean add(final XEntryFilter<? extends E> filter) {
        return this.filters.add(filter);
    }
    
    public boolean remove(final XEntryFilter<? extends E> filter) {
        return this.filters.remove(filter);
    }
    
    public int size() {
        return this.filters.size();
    }
    
    public abstract XMixEntryFilter<E> mix(final XEntryFilter<? extends E> p0);
}
